updateCartQuantity
Method updating the quantity of a line item in cart.
This method sends a POST request to the updateCart endpoint of the Vue Storefront API Middleware and passes the ChangeLineItemQuantity action to it. In turn, it updates the quantity of a line item in commercetools cart by sending a request to its GraphQL API. The default GraphQL query used by this method can be found here.
When the method is called with an incorrect cartVersion and commercetools API responds with the ConcurrentModification error, our Server Middleware automatically retries the failed request with the correct version. To disable that behavior, set the versionFallback to false.
In case you need to perform a more complex cart update with multiple update actions at once, use the updateCart method instead.
Signature
export declare function updateCartQuantity<Res extends PartialUpdateCartResponse = UpdateCartResponse>(
params: UpdateCartQuantityParams,
options?: MethodOptions<CustomQuery<"updateCart">>
): Promise<Res>;Parameters
| Name | Required | Type | Description |
|---|---|---|---|
params | Required | UpdateCartQuantityParams | Parameter object which can be used with this method. Refer to its type definition to learn about possible properties. |
options | Optional | MethodOptions<CustomQuery<"updateCart">> | Options that can be passed to additionally configure the request or customize the logic in a plugin. |
Returns
Returns a representation of the UpdateCartResponse.
Referenced Types
Examples
Updating the quantity of a line item.
import { sdk } from '~/sdk.config.ts';
const { cart } = await sdk.commerce.updateCartQuantity({
cartId: '6931b5d2-986f-4d2b-8cba-45007a26eb5e',
cartVersion: 1,
productId: 'ad7b9df8-8116-4c0e-a6fb-3ce37c98a6b3',
quantity: 3
});Creating a custom GraphQL query for the method in middleware.config.js. We can use it to specify response fields as well as overwrite certain query variables.
module.exports = {
integrations: {
ct: {
// ...
customQueries: {
'update-cart-quantity-custom-query': ({ query, variables, metadata }) => ({
variables: Object.assign(variables, metadata?.variables),
query: `
mutation updateCart(
$id: String!,
$version: Long!,
$actions: [MyCartUpdateAction!]!,
$storeKey: KeyReferenceInput
) {
cart: updateMyCart(id: $id, version: $version, actions: $actions, storeKey: $storeKey) {
${metadata.fields}
}
}
`;
}
}
}
}
};Updating the quantity of a line item and selecting response fields using the custom GraphQL query from the previous example. Notice how we are using the type parameter to overwrite the default response interface.
import { sdk } from '~/sdk.config.ts';
type CustomUpdateCartResponse = {
cart: {
id: string;
version: string;
}
}
const { cart } = await sdk.commerce.updateCartQuantity<CustomUpdateCartResponse>({
cartId: '6931b5d2-986f-4d2b-8cba-45007a26eb5e',
cartVersion: 1,
productId: 'ad7b9df8-8116-4c0e-a6fb-3ce37c98a6b3',
quantity: 3
}, {
customQuery: {
updateCart: 'update-cart-quantity-custom-query',
metadata: {
fields: 'id, version'
}
}
})